#include "Ti86.inc"
#include "ti86asm.inc"
.org _asm_exec_ram
   
    call _runindicoff
    call _clrScrn
    res fmtExponent,(iy+fmtflags)
    res fmtEng,(iy+fmtflags)
    call _homeup
    ld hl,Title
    call _puts
    ld hl,$081f
    ld (_penCol),hl
    ld hl,Author
    call _vputs
    call _getkey
    ld hl,Ques1
    call input
    call save_N
    ld hl,Ques2 
    call input
    call _runindicoff
    call save_D
    xor a           
    ld (_penCol),a
    ld (_penRow),a
   
;----main---------;
    call  clear
    call load_N
    call load_D
    call _FPDIV         ;op1 / op2 ==> op1
    ld a,(_OP1)
    cp $80
    jr nz,not_neg
    ld a,26
    call _vputmap
not_neg:
    xor a
    ld (_OP1),a
    ld (temp),a
    ld (temp+10),a
    call dispOP1
    ld a,'.'
    call _vputmap     
main_loop:
    call load_D         ;_FPDIV changes op2. We need it back.
    rst 28h             ;_FPMULT ==> op1*op2 ==> op1
    rst 08h             ;_op1toop2
    call load_N
    call _FPSUB
    ld a,(_OP1EXPM)
    inc a
    ld (_OP1EXPM),a
    jp c,expl_adj
no_expl_adj:
    call save_N
    call load_D
    call _FPDIV
    call dispOP1
    jp main_loop
expl_adj:
    ld a,(_OP1EXPL)
    inc a
    ld (_OP1EXPL),a
    jp no_expl_adj
;-----------------;


;-----------------;
input: 
    ld de,_ioPrompt
    call _MOV10B
    ld a,$0d
    ld (_ASAP_IND),a
    call _exec_pg3

    ld a,(_OP1EXPM)             ;This I use to fix some error
    ld l,a                      ;in Ti's Floating Point math
    ld a,(_OP1EXPL)             ;routines
    ld h,a
    ld de,$D
    add hl,de
    ld (_OP1EXPM),hl
    ret
;-----------------;

;=====================================
dispOP1:
    call iPart_op1
    ld a,13
    call _formReal
    ld hl,_OP3
    call _vputs   
    ld a,(_penCol)
    cp 124
    ret c
    xor a
    ld (_penCol),a
    ld a,(_penRow)
    add a,6   
    ld (_penRow),a
    cp 58
    ret c
    xor a
    ld (_penRow),a
    ld c,1
key:
    ld a,%01111101
    out (c),a
    in a,(c)
    rra
    jp nc,clear
    ld a,%00111111
    out (c),a
    in a,(c)
    bit 6,a
    jp nz,key
    call _clrScrn
    call _homeup
    jp _jforcecmdnochar
;===================================== 

iPart_op1:
    ld a,(_OP1)
    cp $80
    jp nz,_INTGR
    call _PLUS1
    jp _INTGR


save_N:
    ld de,temp
    jp save_now
save_D:
    ld de,temp+10
save_now:
    ld hl,_OP1
    ld bc,10
    ldir  
    ret  

load_N:
    ld hl,temp
    ld de,_OP1
    jp load_now
load_D:
    ld hl,temp+10
    ld de,_OP2
load_now:
    ld bc,10
    ldir
    ret


clear:
    ld bc,1023
    ld hl,$fc00
    ld (hl),l
    ld de,$fc01
    ldir
    ret 

Title:; |---------------------|
    .db "     Fraction 2      ",0  
Ques1:
    .db "Divide?",0
Ques2:
    .db "By?",0
Author:
    .db "Silvano Bernabel",0
      ; |---------------------|

temp: 
   
.end  
    
    